# -*- coding: utf-8 -*-
import os, sys
import re

import xbmc
import xbmcaddon
import xbmcgui
import xbmcplugin
import xbmcvfs

import urllib, time, json
#import error _strptime - workaround
import _strptime
from datetime import datetime, timedelta
from ga import ga

__addon__ = xbmcaddon.Addon()
__author__ = __addon__.getAddonInfo('author')
__scriptid__ = __addon__.getAddonInfo('id')
__scriptname__ = __addon__.getAddonInfo('name')
__version__ = __addon__.getAddonInfo('version')
__icon__ = __addon__.getAddonInfo('icon').decode("utf-8")
__language__ = __addon__.getLocalizedString
__cwd__ = xbmc.translatePath( __addon__.getAddonInfo('path') ).decode("utf-8")
__profile__ = xbmc.translatePath( __addon__.getAddonInfo('profile') ).decode("utf-8")
__resource__ = xbmc.translatePath( os.path.join( __cwd__, 'resources', 'lib' ) ).decode("utf-8")
__icon_msg__ = xbmc.translatePath( os.path.join( __cwd__, 'resources', 'bulsat.png' ) ).decode("utf-8")
__data__ = xbmc.translatePath(os.path.join( __profile__, '', 'dat') ).decode("utf-8")
__r_path__ = xbmc.translatePath(__addon__.getSetting("w_path")).decode("utf-8")
sys.path.insert(0, __resource__)

dp = xbmcgui.DialogProgressBG()
dp.create(heading = __scriptname__)

def progress_cb (a):
  dp.update(int(a['pr'] * 100), message = a['str'])

def Notify (msg1, msg2):
  xbmc.executebuiltin((u'Notification(%s,%s,%s,%s)' % (msg1, msg2, '5000', __icon_msg__)).encode('utf-8'))

def update(name, dat, crash=None):
  payload = {}
  payload['an'] = __scriptname__
  payload['av'] = __version__
  payload['ec'] = name
  payload['ea'] = 'tv_service'
  payload['ev'] = '1'
  payload['dl'] = urllib.quote_plus(dat.encode('utf-8'))
  ga().update(payload, crash)

__ua_os = {
  '0' : {'ua' : 'pcweb', 'osid' : 'pcweb'},
  '1' : {'ua' : 'samsunghas-agent/1.1', 'osid' : 'samsungtv'},
  '2' : {'ua' : 'HLS Client/2.0 (compatible; LG NetCast.TV-2012)', 'osid' : 'lgtv'},
  '3' : {'ua' : 'Mozilla/5.0 (FreeBSD; Viera; rv:34.0) Gecko/20100101 Firefox/34.0', 'osid' : 'panasonictv'},
  '4' : {'ua' : 'stagefright', 'osid' : 'androidtv'},
}

if os.path.exists(os.path.join(__data__, '', 'data.dat')):
  with open(os.path.join(__data__, '', 'data.dat'), 'r') as f:
    js = json.load(f)
  if not (js.has_key('app_version') and js['app_version'] == __version__):
    u = __addon__.getSetting("username")
    p = __addon__.getSetting("password")

    for root, dirs, files in os.walk(__data__, topdown=False):
      for name in files:
        os.remove(os.path.join(root, name))
      for name in dirs:
        os.rmdir(os.path.join(root, name))
    __addon__.setSetting("firstrun", "true")

if __addon__.getSetting("firstrun") == "true":
  Notify('Settings', 'empty')
  __addon__.openSettings()
  __addon__.setSetting("firstrun", "false")

if __addon__.getSetting("dbg") == 'true':
  dbg = True
else:
  dbg = False

if __addon__.getSetting("xxx") == 'true':
  xxx = True
else:
  xxx = False

if not __addon__.getSetting("username"):
  Notify('User', 'empty')
if not __addon__.getSetting("password"):
  Notify('Password', 'empty')

def dbg_msg(msg):
  if dbg:
    print'### %s: %s' % (__scriptid__, msg)

import traceback
try:
  import bsc
  b = bsc.dodat(base = __addon__.getSetting("base"),
                login = {'usr': __addon__.getSetting("username"),
                        'pass': __addon__.getSetting("password")
                        },
                path = __data__,
                cachetime = float(__addon__.getSetting("refresh")),
                dbg = dbg,
                timeout=float(__addon__.getSetting("timeout")),
                ver = __version__,
                xxx = xxx,
                os_id = __ua_os[__addon__.getSetting("dev_id")]['osid'],
                agent_id = __ua_os[__addon__.getSetting("dev_id")]['ua'],
                proc_cb = progress_cb)

  force = False
  if len(sys.argv) > 1 and sys.argv[1] == 'True':
    force = True

  if b.gen_all(force):
    dbg_msg('Reload PVR')
    xbmc.executebuiltin('XBMC.StartPVRManager')

  if force == False:
    dbg_msg('Reload timer')
    xbmc.executebuiltin('AlarmClock (%s, RunScript(service.bscfusion, False), %s, silent)' % ('__scriptid__', __addon__.getSetting("check_iterval")))

  if __addon__.getSetting("en_cp") == "true" and __addon__.getSetting("w_path") != "" and xbmcvfs.exists(__r_path__):
    xbmcvfs.copy(os.path.join(__data__, '', 'bulsat.xml.gz'), os.path.join(__r_path__, '', 'bulsat.xml.gz'))
    xbmcvfs.copy(os.path.join(__data__, '', 'bulsat.m3u'), os.path.join(__r_path__, '', 'bulsat.m3u'))

  update('refresh', __ua_os[__addon__.getSetting("dev_id")]['osid'])

except Exception, e:
  Notify('Module Import', 'Fail')
  traceback.print_exc()
  update('exception', str(e.args[0]), sys.exc_info())
  pass

dp.close()
